//	Release Version:	$ ODF 2 $
//	Copyright:			(c) 1993 - 1996 by Apple Computer, Inc., all rights reserved.

//================================================================================
#ifndef PART_H
#include "Part.h"
#endif

#ifndef FRAME_H
#include "Frame.h"
#endif

#ifndef DEFINES_K
#include "Defines.k"
#endif

#ifndef BINDING_K
#include "Binding.k"
#endif

// ----- Framework Includes -----
#ifndef FWABOUT_H
#include "FWAbout.h"		//::FW_About()
#endif

#ifndef SLMIXOS_H
#include "SLMixOS.h"		// FW_GetMainScreenBounds
#endif

//==============================================================================
#ifdef FW_BUILD_MAC
#pragma segment GraphicsBfr
#endif

FW_DEFINE_AUTO(CGraphicsBfrPart)
//==============================================================================
CGraphicsBfrPart::CGraphicsBfrPart(ODPart* odPart)
  :	FW_CPart(odPart, FW_gInstance, kPartInfoID),
  	fPresentation(NULL)
{
}

//--------------------------------------------------------------------------------
CGraphicsBfrPart::~CGraphicsBfrPart()
{
}

//--------------------------------------------------------------------------------
void 
CGraphicsBfrPart::Initialize(Environment* ev, ODStorageUnit* storageUnit, 
												FW_Boolean fromStorage)	// Override
{
	FW_CPart::Initialize(ev, storageUnit, fromStorage);
	FW_CSelection* selection = NULL;
	const ODType kMainPresentation = "Apple:Presentation:GraphicsBfr";
	fPresentation = this->RegisterPresentation(ev, kMainPresentation, true, selection);
}

//--------------------------------------------------------------------------------
FW_CFrame* 
CGraphicsBfrPart::NewFrame(Environment* ev, ODFrame* odFrame,
						FW_CPresentation* presentation, FW_Boolean fromStorage)	// Override
{
	FW_UNUSED(fromStorage);
	return FW_NEW(CGraphicsBfrFrame, (ev, odFrame, presentation, this));
}

//----------------------------------------------------------------------------------------
FW_CWindow* 
CGraphicsBfrPart::NewDocumentWindow(Environment* ev)
{	
	FW_CRect screenBounds;
	::FW_GetMainScreenBounds(screenBounds);
	screenBounds.Inset(FW_IntToFixed(3), FW_IntToFixed(3));
	
	return new FW_CWindow(ev,
						this,
					 	FW_CPart::fgViewAsFrameToken,
						fPresentation,
						FW_CPoint(FW_IntToFixed(300), FW_IntToFixed(300)),
						screenBounds.TopLeft(),
						FW_kDocumentWindow);
}

//--------------------------------------------------------------------------------
FW_CContent* 
CGraphicsBfrPart::NewPartContent(Environment* ev)
{
	FW_UNUSED(ev);
	return NULL;
}

//--------------------------------------------------------------------------------
FW_Handled 
CGraphicsBfrPart::DoAbout(Environment* ev)
{
	::FW_About(ev, this, kAbout);
	
	return FW_kHandled;
}

